XdkWrl: IndexedFaceSet Class Reference

Home | Hierarchy | Members | Alphabetical | Related Pages

# IndexedFaceSet Class Reference
[Standard Node Types]

`#include <indexedfaceset.h>`

Inherits Node.

List of all members.

## Public Member Functions
| IndexedFaceSet (const char *name="")
virtual | ~IndexedFaceSet ()
virtual unsigned int | nbFields () const
virtual FieldHandle | field (const std::string &n)
virtual FieldHandle | field (unsigned int i)
virtual bool | isSetToDefaultValue (unsigned int i) const
virtual unsigned int | nbEventsIn () const
virtual EventInHandle | eventIn (const std::string &n)
virtual EventInHandle | eventIn (unsigned int i)
virtual unsigned int | nbEventsOut () const
virtual EventOutHandle | eventOut (const std::string &n)
virtual EventOutHandle | eventOut (unsigned int i)
const char * | typeName () const
virtual Node * | duplicate () const
virtual Node * | duplicate (std::map< const Node *, Node * > &) const
## Public Attributes
Exposed Fields
A field that is capable of receiving events via an eventIn to change its value(s), and generating events via an eventOut when its value(s) change.
SFNode | color
SFNode | coord
SFNode | normal
SFNode | texCoord
Fields
A property or attribute of a node. Each node type has a fixed set of fields. Fields may contain various kinds of data and one or many values. Each field has a default value.
SFBool | ccw
MFInt32 | colorIndex
SFBool | colorPerVertex
SFBool | convex
MFInt32 | coordIndex
SFFloat | creaseAngle
MFInt32 | normalIndex
SFBool | normalPerVertex
SFBool | solid
MFInt32 | texCoordIndex
Events In
EventIn< MFInt32 > | set_colorIndex
EventIn< MFInt32 > | set_coordIndex
EventIn< MFInt32 > | set_normalIndex
EventIn< MFInt32 > | set_texCoordIndex
EventIn< SFNode > | set_color
EventIn< SFNode > | set_coord
EventIn< SFNode > | set_normal
EventIn< SFNode > | set_texCoord
Events Out
EventOut< SFNode > | color_changed
EventOut< SFNode > | coord_changed
EventOut< SFNode > | normal_changed
EventOut< SFNode > | texCoord_changed

## Detailed Description

Here is the documentation for this node type, from the ISO standard.

## 6.34 IndexedFaceSet

The IndexedFaceSet node represents a 3D shape formed by constructing faces (polygons) from vertices listed in the coord field. The coord field contains a Coordinate or GeoCoordinate node that defines the 3D vertices referenced by the coordIndex field. IndexedFaceSet uses the indices in its coordIndex field to specify the polygonal faces by indexing into the coordinates in the Coordinate or GeoCoordinate node. An index of "-1" indicates that the current face has ended and the next one begins. The last face may be (but does not have to be) followed by a "-1" index. If the greatest index in the coordIndex field is N, the Coordinate or GeoCoordinate node shall contain N+1 coordinates (indexed as 0 to N). Each face of the IndexedFaceSet shall have:

1. at least three non-coincident vertices;
2. vertices that define a planar polygon;
3. vertices that define a non-self-intersecting polygon.

Otherwise, The results are undefined.

The IndexedFaceSet node is specified in the local coordinate system and is affected by the transformations of its ancestors.

Descriptions of the coord, normal, and texCoord fields are provided in the Coordinate, Normal, and TextureCoordinate nodes, respectively.

Details on lighting equations and the interaction between color field, normal field, textures, materials, and geometries are provided in 4.14, Lighting model.

If the color field is not NULL, it shall contain a Color node whose colours are applied to the vertices or faces of the IndexedFaceSet as follows:

4. If colorPerVertex is FALSE, colours are applied to each face, as follows:
   1. If the colorIndex field is not empty, then one colour is used for each face of the IndexedFaceSet. There shall be at least as many indices in the colorIndex field as there are faces in the IndexedFaceSet. If the greatest index in the colorIndex field is N, then there shall be N+1 colours in the Color node. The colorIndex field shall not contain any negative entries.
   2. If the colorIndex field is empty, then the colours in the Color node are applied to each face of the IndexedFaceSet in order. There shall be at least as many colours in the Color node as there are faces.
5. If colorPerVertex is TRUE, colours are applied to each vertex, as follows:
   1. If the colorIndex field is not empty, then colours are applied to each vertex of the IndexedFaceSet in exactly the same manner that the coordIndex field is used to choose coordinates for each vertex from the Coordinate or GeoCoordinate node. The colorIndex field shall contain at least as many indices as the coordIndex field, and shall contain end-of-face markers (-1) in exactly the same places as the coordIndex field. If the greatest index in the colorIndex field is N, then there shall be N+1 colours in the Color node.
   2. If the colorIndex field is empty, then the coordIndex field is used to choose colours from the Color node. If the greatest index in the coordIndex field is N, then there shall be N+1 colours in the Color node.

If the color field is NULL, the geometry shall be rendered normally using the Material and texture defined in the Appearance node (see 4.14, Lighting model, for details).

If the normal field is not NULL, it shall contain a Normal node whose normals are applied to the vertices or faces of the IndexedFaceSet in a manner exactly equivalent to that described above for applying colours to vertices/faces (where normalPerVertex corresponds to colorPerVertex and normalIndex corresponds to colorIndex). If the normal field is NULL, the browser shall automatically generate normals, using creaseAngle to determine if and how normals are smoothed across shared vertices (see 4.6.3.5, Crease angle field).

If the texCoord field is not NULL, it shall contain a TextureCoordinate node. The texture coordinates in that node are applied to the vertices of the IndexedFaceSet as follows:

6. If the texCoordIndex field is not empty, then it is used to choose texture coordinates for each vertex of the IndexedFaceSet in exactly the same manner that the coordIndex field is used to choose coordinates for each vertex from the Coordinate or GeoCoordinate node. The texCoordIndex field shall contain at least as many indices as the coordIndex field, and shall contain end-of-face markers (-1) in exactly the same places as the coordIndex field. If the greatest index in the texCoordIndex field is N, then there shall be N+1 texture coordinates in the TextureCoordinate node.
7. If the texCoordIndex field is empty, then the coordIndex array is used to choose texture coordinates from the TextureCoordinate node. If the greatest index in the coordIndex field is N, then there shall be N+1 texture coordinates in the TextureCoordinate node.

If the texCoord field is NULL, a default texture coordinate mapping is calculated using the local coordinate system bounding box of the shape. The longest dimension of the bounding box defines the S coordinates, and the next longest defines the T coordinates. If two or all three dimensions of the bounding box are equal, ties shall be broken by choosing the X, Y, or Z dimension in that order of preference. The value of the S coordinate ranges from 0 to 1, from one end of the bounding box to the other. The T coordinate ranges between 0 and the ratio of the second greatest dimension of the bounding box to the greatest dimension. Figure 6.10 illustrates the default texture coordinates for a simple box shaped IndexedFaceSet with an X dimension twice as large as the Z dimension and four times as large as the Y dimension. Figure 6.11 illustrates the original texture image used on the IndexedFaceSet used in Figure 6.10.

####
Figure 6.10 -- IndexedFaceSet texture default mapping

####
Figure 6.11 -- ImageTexture for IndexedFaceSet in Figure 6.10

Subclause 4.6.3, Shapes and geometry, provides a description of the ccw, solid, convex, and creaseAngle fields.

## Constructor & Destructor Documentation

IndexedFaceSet | ( | const char * | name = `""` | ) |

Construct a node with all its fields set to default value, which is equivalent to the code below:

      ccw = true;
      colorPerVertex = true;
      convex = true;
      creaseAngle = 0.0f;
      normalPerVertex = true;
      solid = true;

~IndexedFaceSet | ( |  | ) | `[virtual]`

Virtual destructor, does nothing

## Member Function Documentation

unsigned int nbFields | ( |  | ) | const`[inline, virtual]`

Returns the number of fields (exposed or not) for this node type.

Implements Node.

wrl::Node::FieldHandle field | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the field named `n` of the node or a "unknown" typed handle if there is no such field. Valid names are:

- color
- coord
- normal
- texCoord
- ccw
- colorIndex
- colorPerVertex
- convex
- coordIndex
- creaseAngle
- normalIndex
- normalPerVertex
- solid
- texCoordIndex

Implements Node.

wrl::Node::FieldHandle field | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th field of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : color
- 1 : coord
- 2 : normal
- 3 : texCoord
- 4 : ccw
- 5 : colorIndex
- 6 : colorPerVertex
- 7 : convex
- 8 : coordIndex
- 9 : creaseAngle
- 10 : normalIndex
- 11 : normalPerVertex
- 12 : solid
- 13 : texCoordIndex This function is useful, with nbFields() if you want to traverse all fields of a Node.

Implements Node.

bool isSetToDefaultValue | ( | unsigned int | i | ) | const`[virtual]`

Implements Node.

unsigned int nbEventsIn | ( |  | ) | const`[inline, virtual]`

Returns the number of events in for this node type.

Implements Node.

wrl::Node::EventInHandle eventIn | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event in named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- set_colorIndex
- set_coordIndex
- set_normalIndex
- set_texCoordIndex
- set_color
- set_coord
- set_normal
- set_texCoord

Implements Node.

wrl::Node::EventInHandle eventIn | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event in of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : set_colorIndex
- 1 : set_coordIndex
- 2 : set_normalIndex
- 3 : set_texCoordIndex
- 4 : set_color
- 5 : set_coord
- 6 : set_normal
- 7 : set_texCoord

This function is useful, with nbEventsIn() if you want to traverse all events in of a Node.

Implements Node.

unsigned int nbEventsOut | ( |  | ) | const`[inline, virtual]`

Returns the number of events out for this node type.

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event out named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- color_changed
- coord_changed
- normal_changed
- texCoord_changed

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event out of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : color_changed
- 1 : coord_changed
- 2 : normal_changed
- 3 : texCoord_changed This function is useful, with nbEventsOut() if you want to traverse all events in of a Node.

Implements Node.

const char * typeName | ( |  | ) | const`[inline, virtual]`

Returns `"IndexedFaceSet"`. Useful for printing.

Implements Node.

wrl::Node * duplicate | ( |  | ) | const`[virtual]`

Returns a deep copy of this node, that is a fully independant node with all children (if any) also copied. This is mainly useful for instanciating protos.

Implements Node.

virtual Node* duplicate | ( | std::map< const Node *, Node * > & |  | ) | const`[virtual]`

Implements Node.

## Member Data Documentation

SFNode color

See Detailed Description for meaning of this field. Default value is set to SFNode default value

SFNode coord

See Detailed Description for meaning of this field. Default value is set to SFNode default value

SFNode normal

See Detailed Description for meaning of this field. Default value is set to SFNode default value

SFNode texCoord

See Detailed Description for meaning of this field. Default value is set to SFNode default value

SFBool ccw

See Detailed Description for meaning of this field. Default value is set to

           ccw = true;

MFInt32 colorIndex

See Detailed Description for meaning of this field. Default value is set to MFInt32 default value

SFBool colorPerVertex

See Detailed Description for meaning of this field. Default value is set to

           colorPerVertex = true;

SFBool convex

See Detailed Description for meaning of this field. Default value is set to

           convex = true;

MFInt32 coordIndex

See Detailed Description for meaning of this field. Default value is set to MFInt32 default value

SFFloat creaseAngle

See Detailed Description for meaning of this field. Default value is set to

           creaseAngle = 0.0f;

MFInt32 normalIndex

See Detailed Description for meaning of this field. Default value is set to MFInt32 default value

SFBool normalPerVertex

See Detailed Description for meaning of this field. Default value is set to

           normalPerVertex = true;

SFBool solid

See Detailed Description for meaning of this field. Default value is set to

           solid = true;

MFInt32 texCoordIndex

See Detailed Description for meaning of this field. Default value is set to MFInt32 default value

EventIn<MFInt32> set_colorIndex

See Detailed Description for meaning of this event.

EventIn<MFInt32> set_coordIndex

See Detailed Description for meaning of this event.

EventIn<MFInt32> set_normalIndex

See Detailed Description for meaning of this event.

EventIn<MFInt32> set_texCoordIndex

See Detailed Description for meaning of this event.

EventIn<SFNode> set_color

Set event associated to exposedField color

EventIn<SFNode> set_coord

Set event associated to exposedField coord

EventIn<SFNode> set_normal

Set event associated to exposedField normal

EventIn<SFNode> set_texCoord

Set event associated to exposedField texCoord

EventOut<SFNode> color_changed

Changed event associated to exposedField color

EventOut<SFNode> coord_changed

Changed event associated to exposedField coord

EventOut<SFNode> normal_changed

Changed event associated to exposedField normal

EventOut<SFNode> texCoord_changed

Changed event associated to exposedField texCoord

Generated on 5 Jan 2007 with version 1.5.1. |